unit Unit1;     

////////////////////////////////////////////////////////////////////////////////
//                                                                            //
//  Let's solve the next system:                                              //
//                                                                            //
//  dx0/dt = 2t                                                               //
//  dx1/dt = 3x0                                                              //
//                                                                            //
//  With next initional conditions:                                           //
//                                                                            //
//  x0(0)=0                                                                   //
//  x1(0)=0                                                                   //
//                                                                            //
//  Answer is:                                                                //
//                                                                            //
//  x0(t)=t^2                                                                 //
//  x1(t)=t^3                                                                 //
//                                                                            //
////////////////////////////////////////////////////////////////////////////////

interface

uses
  SysUtils, Forms, StdCtrls, Controls, Classes, Dialogs;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    rk_But: TButton;
    procedure rk_ButClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;


implementation

uses rk_method, Windows;




{$R *.dfm}


////////////////////////////////////////////////////////////////////////////////
//                                                                            //
// t - is independent var,                                                    //
// X[0] -> x0,                                                                //
// X[1] -> x1, etc.                                                           //

procedure Syst (var t: TFloat; var X: TFloatVector;
                var RP: TFloatVector);
begin
  RP[0] := 2*t;     //means dx0/dt = 2t
  RP[1] := 3*X[0];  //means dx1/dt = 3x0
end;


//                                                                            //
//                                                                            //
////////////////////////////////////////////////////////////////////////////////




procedure TForm1.rk_ButClick(Sender: TObject);
var
    I, t1, t2: Cardinal;
    tOut, InitConds: TFloatVector;
    XOuts: TFloatMatrix;
    Points: Cardinal;
    First, Last: TFloat; 
    StepsFact: Cardinal;     
    Count: Word;
begin

    Memo1.Clear;

    First := 0.0;
    Last  := 10.0;
    Count:= 2;
    Points:=10+1; //11 points for output
    StepsFact:=1000000; //all steps inside function = 10*StepsFact

    try
    SetLength(InitConds, Count);
      InitConds[0]:=0.0;  //x0(0)=0
      InitConds[1]:=0.0;  //x1(0)=0
      SetLength(tOut, Points);
      SetLength(XOuts, Count, Points);
    except
      ShowMessage('Out of memory!!!');
      exit;
    end;

    t1:= GetTickCount();
    I := rk4fixed( Syst, InitConds, First, Last, tOut, XOuts, StepsFact );
    t2:= GetTickCount();
    Memo1.Lines.Add('Error Code = ' + IntToStr(I));
    Memo1.Lines.Add('Run time, ms = ' + IntToStr(t2-t1));
    Memo1.Lines.Add('');
    if I = 0 then
    for I := 0 to Points - 1 do
        Memo1.Lines.Add(
                   't = '+ FloatToStr(TOut[I])+
        '           x0 = '+ FloatToStr(XOuts[0, I])+
        '           x1 = '+ FloatToStr(XOuts[1, I])
        );
    //Clean memory:
    XOuts := Nil; tOut := Nil; InitConds := Nil;

end;

end.
